export async function Wrap(eTrack, sLyrics) {
    eTrack.lyrics = new Map([ [ 0, sLyrics ] ])
}

export async function Download(eTrack) {
	if(!eTrack.artist) {
        return
    }

    let r = await createLrcLibRequest(eTrack)
    if(!r.ok) {
    	return
    }

    let d = await r.json()
    let l = parseSyncedLyrics(d.syncedLyrics)
    if(l.size > 0) {
        eTrack.lyrics = l
    }
}

export function createLrcLibRequest(eTrack) {
    let e = new URL('https://lrclib.net/api/get', window.location)

    e.searchParams.set('track_name', eTrack.name)
    e.searchParams.set('artist_name', eTrack.artist)
    if(eTrack.album) {
        e.searchParams.set('album_name', eTrack.album)
    }
    // if(eTrack.duration != undefined) {
        // e.searchParams.set('duration', parseInt(eTrack.duration))
    // }

    return fetch(e, {
        headers: {
            "Lrclib-Client": "hiss Audio Player"
        }
    })
}

export const syncedLyricsRegex = /^\[(?<minutes>\d+):(?<seconds>\d+\.\d+)\] (?<line>.*)$/mg
export function parseSyncedLyrics(sSyncedLyrics) {
    let out = new Map()
    let m

    while ((m = syncedLyricsRegex.exec(sSyncedLyrics)) !== null) {
        if (m.index === syncedLyricsRegex.lastIndex) {
            regex.lastIndex++
        }

        let s = parseInt(m.groups.minutes) * 60
        s += parseFloat(m.groups.seconds)
        out.set(s, m.groups.line)
    }

    return out
}
