window.hiss = {
    state: {},
    view: {}
}

import * as index from './index/index.js'
import * as view from './view/view.js'
import * as player from './view/player.js'
import * as browser from './view/browser.js'
import * as queue from './view/queue.js'
import Store from 'store'
import * as device from 'device'

export const db = await Store.Open('state', 'data')

export async function Start() {
    await device.Start()
    await openState()

    await view.Init()
}

export async function openState() {
    let s = await db.Get('state')

    if(s) {
        Object.assign(hiss.state, s)
    } else {
        await State()
        await saveState()
    }

    return s != undefined
}

export async function saveState() {
    await db.Set('state', hiss.state)
}

export async function Reset() {    
    await db.Set('state', null)
    window.location.reload()
}

export async function State() {
    await index.State()
    await view.State()
}

{
    Object.assign(window, {
        view,
        player,
        browser,
        queue,
        device,
        index,
        
        Reset,
        Start,
        saveState,
        db
    })

    Start()
}