import * as index from '../index/index.js'

export let Elements

export function Init() {
	Elements = new Array(hiss.indexSize)
	for(let entry of hiss.entries) {
		Elements[entry.id] = Render(entry)
	}
}

export function Get(element) {
    return hiss.entries[element.dataset.id]
}

export function Render(entry) {
    let li = document.createElement('li')

    li.dataset.id = entry.id

    if(index.IsTrack(entry)) {
        populateTrackEntry(entry, li)
    } else {
        populateListEntry(entry, li)
    }

    return li
}

const populateListEntry = (entry, li) => {
    let a = document.createElement('a')
    let header = document.createElement('header')

    header.innerText = entry.name
    a.appendChild(header)
    li.appendChild(a)

    li.dataset.actionSet = 'browser-list'
}

const populateTrackEntry = (entry, li) => {
    // TODO: fix button problem on kaios
    let p = document.createElement('p')

    let trackNumber = document.createElement('code')
    let title = document.createElement('b')
    let artist = document.createElement('cite')

    trackNumber.innerText = formatTrackNumber(entry.trackNumber)
    title.innerText = entry.name
    artist.innerText = entry.artist

    p.appendChild(title)
    p.appendChild(artist)

    li.appendChild(trackNumber)
    li.appendChild(p)

    li.dataset.actionSet = 'browser-track'
}

const formatTrackNumber = trackNumber => {
    return trackNumber == Infinity ? '--' : trackNumber.toString().padStart(2, '0')
}